unit demoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HalComp, StdCtrls, Buttons, ExtCtrls,IntLists,
  Menus,halinsp,getdemo, ComCtrls;

type
  TMyHalMainForm = class(TForm)
    Panel1: TPanel;
    playbutton: TSpeedButton;
    HalComp1: THalComp;
    openbutton: TSpeedButton;
    newbutton: TSpeedButton;
    savebutton: TSpeedButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Run1: TMenuItem;
    Open1: TMenuItem;
    Saveas1: TMenuItem;
    New1: TMenuItem;
    Bevel1: TBevel;
    SpeedButton1: TSpeedButton;
    View1: TMenuItem;
    Browser1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Tools1: TMenuItem;
    Importunit1: TMenuItem;
    SpeedButton2: TSpeedButton;
    PageControl1: TPageControl;
    SourceSheet: TTabSheet;
    OutputSheet: TTabSheet;
    OutPut: TMemo;
    ProgText: TMemo;
    procedure playbuttonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure savebuttonClick(Sender: TObject);
    procedure newbuttonClick(Sender: TObject);
    procedure openbuttonClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Importunit1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Showallforms1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ProgFile:String;
    V0,V1:String;
    constructor Create(AOwner: TComponent);override;
  end;

var
  MyHalMainForm: TMyHalMainForm;

implementation

{$R *.DFM}

const stnoname:String='NoName.HAL';

constructor TMyHalMainForm.Create(AOwner: TComponent);
begin
inherited;
ProgFile:=stNoname;
end;


procedure TMyHalMainForm.playbuttonClick(Sender: TObject);
var v:variant;
begin
 PageControl1.ActivePage:=OutputSheet;
 HalComp1.FScriptChanged:=true;
 HalCOmp1.Script.Clear;
 HalComp1.Script.AddStrings(ProgText.Lines);
 v:=HalComp1.Result;
end;
{--------------------------------}
procedure TMyHalMainForm.FormCreate(Sender: TObject);
begin
  OutMemo:=OutPut;
  PageControl1.ActivePage:=SourceSheet;
end;
{--------------------------------}
procedure TMyHalMainForm.savebuttonClick(Sender: TObject);
begin
savedialog1.filename:=progfile;
if savedialog1.execute then begin
Progtext.lines.SaveTOFIle(savedialog1.filename);
progfile:=savedialog1.filename;
end;
end;
{--------------------------------}
procedure TMyHalMainForm.newbuttonClick(Sender: TObject);
begin
ProgText.lines.Clear;
end;
{--------------------------------}
procedure TMyHalMainForm.openbuttonClick(Sender: TObject);
var F:TForm;
begin
if opendialog1.execute then begin
If CompareText(AnsiUpperCase(ExtractFileExt(opendialog1.filename)),'.DFM')=0
then begin
      F:=TForm.Create(Application);
      MyReadComponentResFile(opendialog1.filename,F);
      F.Show;
     end
else begin
      Progtext.Clear;
      Progtext.lines.LoadFromFile(opendialog1.filename);
      ProgFile:=opendialog1.filename;
     end;
end;
end;
{--------------------------------}
procedure TMyHalMainForm.SpeedButton1Click(Sender: TObject);
begin
 ShowInspector;
end;
{--------------------------------}
procedure TMyHalMainForm.Exit1Click(Sender: TObject);
begin
 Close;
end;
{--------------------------------}
procedure TMyHalMainForm.Importunit1Click(Sender: TObject);
begin
 GetUnitForm.ShowModal;
end;
{--------------------------------}
procedure TMyHalMainForm.SpeedButton2Click(Sender: TObject);
begin
 OutPut.Clear;
end;
{--------------------------------}
procedure TMyHalMainForm.Showallforms1Click(Sender: TObject);
var i:integer;
begin
 For i:=0 to Application.ComponentCount-1 do
 if Application.Components[i] is TForm then
  TForm(Application.Components[i]).Show;
end;

end.
